/***************************************************************************
                          find.h  -  description
                             -------------------
    begin                : Mon Feb 19 2001
    copyright            : (C) 2001 by Stefano Brustia
    email                : hio@lombardiacom.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FIND_H
#define FIND_H

#include <qtabwidget.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qdialog.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>

/*#include "mp3kultview.h"*/
#include "resources.h"

class Mp3Find : public QWidget
{
     Q_OBJECT

public:
        Mp3Find(QWidget* parent = 0, const char* name = 0);
        void findnext();
        void disableItem(int id);
        void enableItem(int id);

protected slots:
     void slotbutok();
     void slotbutcancel();

signals:
     void search(QString, bool);
     void advsearch(QString, bool, const bool*);

private:

      void initFindDialog();
      void initAdvSearch();
     /* bool search();*/

     bool options [SOPTIONS];

      QTabWidget* tabWidget;
      QWidget* searchW;
      QWidget* advsearchW;
      QLineEdit* word;
      QLineEdit* advword;
      QButtonGroup* gSearchIn;
      QCheckBox* cTitle;
      QCheckBox* cArtist;
      QCheckBox* cAlbum;
      QCheckBox* cGenre;
      QCheckBox* cYear;
      QCheckBox* cComment;
      QCheckBox* cLength;
      QCheckBox* cPath;
      QCheckBox* cFname;
      QCheckBox* cVolume;
      QCheckBox* cSize;
      QCheckBox* cMode;
      QCheckBox* cBit;
      QCheckBox* cSample;
      QPushButton* butok;
      QPushButton* butcancel;
};

#endif
